#include "descriptor/descriptor.h"

int main(void) {

	ITEM	plastica_finale, metallo, base, wood, muro, colore_aperitivo;
	ITEM	blu, ottone, azzurro;
	ITEM	griglia_list, griglia, table, base_griglia, mobile, metallo_griglia;
	ITEM	tavolo_list, tavolo_base, tavolo_piedistallo, metallo_piedistallo, glass_tavolo;
	ITEM	bicchieri, bicchiere, bicchiere_1, bicchiere_2, ciliegia, aperitivo, glass_bicchiere;
	ITEM	cherry_list, ciliegia_corpo, ciliegia_gambo, ciliegia_finale, colore_ciliegia, colore_gambo, colore_finale;
	ITEM	muro_list, floor, muro_f, muro_l, muro_r, muro_b, soffitto, colore_pavimento;
	ITEM	dart_pa, dart_ca, dart_fa, dart_a1, dart_a2, dart_a3;
 	ITEM	dart_pb, dart_cb, dart_fb, dart_b1, dart_b2, dart_b3;
	ITEM	dart_list, darts, dart_1, dart_2, dart_3, dart_4, dart_5, dart_1t, dart_2t;
	ITEM	foglio, colore_foglio;
	ITEM	battiscopa_list, battiscopa_f, battiscopa_l, battiscopa_r, battiscopa_b, colore_battiscopa;
	ITEM	scene;

	set_background(1.0,1.0,1.0, FALSE);
	set_ambient_light(0.73,0.73,0.73, 0.7);

	/*** LIGHT DEFINITION ***/
	
	create_warn_light(-48.4,-55.2,2.9,	0.113,0.980,0.159,	1,1,1,	2.5, 100, 1, 25, 0,0,0,0,0, "warn light1");
	create_warn_light(60.0,-57.0,23.0,	-0.727,0.672,-0.140,	1,1,1,	2.0, 150, 1, 40, 0,0,0,0,0, "warn light2");
	create_warn_light(25.0,-58.0,85.0,	-0.231,0.588,-0.774,	1,1,1,	2.3, 80, 1, 55, 0,0,0,0,0, "warn light3");
	create_warn_light(27.6,-41.5,19.9,	-0.540,0.743,-0.394,	1,1,1,	1.7, 100, 1, 50, 0,0,0,0,0, "warn light4");

	/*** ATTRIBUTE DEFINITION ***/
	
	/*** ATTRIBUTE plastica_finale ***/
	plastica_finale = create_attribute("plastica_finale");
		set_color(plastica_finale,0.89,0.76,0.65,0.1,0.8);
		set_reflectivity(plastica_finale,0.2,128);

	/*** ATTRIBUTE ottone ***/
	ottone = create_attribute("ottone");
		set_color(ottone,174/255.0,109/255.0,0.0,0.2,0.8);
		set_reflectivity(ottone,0.1,2);

	/*** ATTRIBUTE blu ***/
	blu = create_attribute("blu");
		set_color(blu,50/255.0,0,1,0.8,0.3);
		set_reflectivity(blu,0.01,4);
		set_transparency(blu,0.3,0.1,2,1.0);

	/*** ATTRIBUTE azzurro ***/
	azzurro = create_attribute("azzurro");
		set_color(azzurro,50/255.0, 220/255.0, 250/255.0, 0.9, 0.2);
		set_reflectivity(azzurro,0.05,5);
		
	/*** ATTRIBUTE colore_foglio ***/
	colore_foglio = create_attribute("colore_foglio");
		set_color(colore_foglio,1.0,1.0,0.0,0.9,0.4);

	/*** ATTRIBUTE metallo ***/
	metallo = create_attribute("metallo");
		set_color(metallo, 0.6, 0.6, 0.6, 0.9, 0.81 );
		set_reflectivity(metallo,0.2,2);

	/*** ATTRIBUTE mettalo_griglia ***/ 
	metallo_griglia = create_attribute("metallo_griglia");
		set_color(metallo_griglia, 100/255.0, 100/255.0, 100/255.0, 0.62, 0.71 );
		set_reflectivity(metallo_griglia,0.35,2);
  
	/*** ATTRIBUTE metallo_piedistallo ***/
	metallo_piedistallo = create_attribute("metallo_piedistallo");
		set_color(metallo_piedistallo, 0, 0, 0, 0.62, 0.71 );
		set_reflectivity(metallo_piedistallo,0.25,2); 
  
	/*** ATTRIBUTE base ***/
	base = create_attribute("base");
		set_color(base, 1.0, 0.078, 0.12, 1.0, 0.87 );
		set_reflectivity(base,0.0,0);

	/*** ATTRIBUTE wood ***/
	wood = create_attribute("colore_wood");
		set_color(wood, 1.0, 0.2, 0.0, 0.6, 0.8);
		set_reflectivity(wood, 0.05, 5);

	/*** ATTRIBUTE muro ***/
	muro = create_attribute("colore_muro");
		set_color(muro, 1.0, 1.0, 1.0, 1, 0.8);

	/*** ATTRIBUTE colore_pavimento ***/
	colore_pavimento = create_attribute("colore_pavimento");
		set_color(colore_pavimento, 0, 0, 0, 0.8, 0.4);
		set_reflectivity(colore_pavimento, 0.02, 5);

	/*** ATTRIBUTE colore_battiscopa ***/
	colore_battiscopa = create_attribute("colore_battiscopa");
		set_color(colore_battiscopa, 0.2, 0.2, 0.2, 1, 0.3);
		set_reflectivity(colore_battiscopa, 0.1, 5);
		
	/*** ATTRIBUTE colore_aperitivo ***/
	colore_aperitivo = create_attribute("colore_aperitivo");
		set_color(colore_aperitivo,32/255.0,228/255.0, 0.0,1.0,0.250);
		set_reflectivity(colore_aperitivo,0.1,2);
		set_transparency(colore_aperitivo,0.8,0.7,0,1.33);

	/*** ATTRIBUTE colore_ciliegia ***/
	colore_ciliegia = create_attribute("colore_ciliegia");
		set_color(colore_ciliegia, 1.0, 0.1, 0.0, 0.6, 0.8);
		set_reflectivity(colore_ciliegia, 0.1, 5);

	/*** ATTRIBUTE colore_finale ***/
	colore_finale = create_attribute("colore_finale");
		set_color(colore_finale, 0.47, 0.41, 0.20, 0.6, 0.8);
		set_reflectivity(colore_finale, 0.1, 0);

	/*** ATTRIBUTE colore_gambo ***/
	colore_gambo = create_attribute("colore_gambo");
		set_color(colore_gambo, 0.33,0.48,0.2, 0.6, 0.8);
		set_reflectivity(colore_gambo, 0.1, 0);

	/*** ATTRIBUTE glass_bicchiere ***/
	glass_bicchiere = create_attribute("glass_bicchiere");
		set_color(glass_bicchiere,0.207,0.757,0.635,0.38,0.25);
		set_reflectivity(glass_bicchiere,0.15,2);
		set_transparency(glass_bicchiere,0.73,0.63,2,1.2);

	/*** ATTRIBUTE glass_tavolo ***/
	glass_tavolo = create_attribute("glass_tavolo");
		set_color(glass_tavolo, 0, 0, 0, 0.8, 0.5);
		set_reflectivity(glass_tavolo,0.24,2);
		set_transparency(glass_tavolo,0.87,0.68,0,1.2);	
	
	/*** OBJECT DEFINITION ***/
	
	/*** OBJECT Griglia darts ***/
	griglia = read_obj("griglia_03.obj", "griglia");
		set_attribute(griglia, metallo_griglia);
		set_z_rotate(griglia, 9, 1);
	base_griglia = read_nurbs("base_04t.db");
		set_scale(base_griglia, 0.086956522, 0.086956522, 1);
		set_projection_texture(base_griglia, base, "textures/bersaglio_05.hr", 2, FALSE, 0.6, 0.8);
		set_scale(base_griglia, 11.5, 11.5, 1);
		set_z_rotate(base_griglia,189,1);
		
	griglia_list = create_list(griglia, "griglia_list");
	griglia_list = insert_in_list(griglia_list, base_griglia);

	/*** OBJECT Mobile bersaglio ***/
	mobile = read_obj("mobile_03.obj", "mobile");
		set_scale(mobile, 0.1, 0.1, 1);
		set_projection_texture(mobile, wood, "textures/wood039.hr", 0, TRUE, 0.6, 0.8);
		set_scale(mobile, 10, 10, 1);
	
	foglio = read_nurbs("foglio_02.db");
		set_domain_texture(foglio, colore_foglio, "textures/foglio_04b.hr", 0, 1, 0, 1, FALSE, 0.8, 0.5);
		set_x_rotate(foglio, -88, 1);
		set_y_rotate(foglio, -90, 1);
		set_z_rotate(foglio, 165, 1);
		set_translate(foglio, -6.0, 10.5, 0.3);
	
	/*** OBJECT Freccette ***/
	dart_pa = read_nurbs("punta_end_06.db");
		set_attribute(dart_pa, ottone);
	dart_ca = read_nurbs("corpo_end_06b.db");
		set_attribute(dart_ca, metallo);
	dart_fa = read_nurbs("finale_end_06.db");
		set_attribute(dart_fa, plastica_finale);
	dart_a1 = read_nurbs("aletta_end_07a.db");
		set_attribute(dart_a1, blu);
	dart_a2 = read_nurbs("aletta_end_07b.db");
		set_attribute(dart_a2, blu);
	dart_a3 = read_nurbs("aletta_end_07c.db");
		set_attribute(dart_a3, blu);
		
 	dart_pb = create_copy(dart_pa, "punta_end_06.db");
 	dart_cb = create_copy(dart_ca, "corpo_end_06.db");
 	dart_fb = create_copy(dart_fa, "finale_end_06.db");
 	dart_b1 = create_copy(dart_a1, "aletta_1");
 		set_attribute(dart_b1, azzurro);
 	dart_b2 = create_copy(dart_a2, "aletta_2");
 		set_attribute(dart_b2, azzurro);
 	dart_b3 = create_copy(dart_a3, "aletta_3");
 		set_attribute(dart_b3, azzurro);
	
	dart_1 = create_list(dart_pa, "dart_1");
	dart_1 = insert_in_list(dart_1, dart_ca);
	dart_1 = insert_in_list(dart_1, dart_fa);
	dart_1 = insert_in_list(dart_1, dart_a1);
	dart_1 = insert_in_list(dart_1, dart_a2);
	dart_1 = insert_in_list(dart_1, dart_a3);
	
	dart_1t = create_copy(dart_1, "dart_1t");
	dart_2t = create_copy(dart_1, "dart_2t");

		set_translate(dart_1, 0.0, 0.0, 2.0);
	
	dart_2 = create_copy(dart_1, "dart_2");
	dart_3 = create_copy(dart_1, "dart_3");
//	dart_4 = create_copy(dart_1, "dart_4");
//	dart_5 = create_copy(dart_1, "dart_5");
 	dart_5 = create_list(dart_pb, "dart_5");
 	dart_5 = insert_in_list(dart_5, dart_cb);
 	dart_5 = insert_in_list(dart_5, dart_fb);
 	dart_5 = insert_in_list(dart_5, dart_b1);
 	dart_5 = insert_in_list(dart_5, dart_b2);
 	dart_5 = insert_in_list(dart_5, dart_b3);

		set_translate(dart_5, 0.0, 0.0, 2.0);

	dart_4 = create_copy(dart_5, "dart_4");

		set_z_rotate(dart_1, 15, 1);
		set_x_rotate(dart_1, 8, 1);
		set_y_rotate(dart_1, 1, 1);

		set_z_rotate(dart_2, 40, 1);
		set_x_rotate(dart_2, 10, 1);
		set_y_rotate(dart_2, -2, 1);
		set_translate(dart_2, 5, 4, 0.0);
		
		set_z_rotate(dart_3, 90, 1);
		set_x_rotate(dart_3, 5, 1);
		set_y_rotate(dart_3, -2, 1);
		set_translate(dart_3, -2.5, -2.2, 0.0);
		
		set_z_rotate(dart_4, 55, 1);
		set_x_rotate(dart_4, 15, 1);
		set_y_rotate(dart_4, 2, 1);
		set_translate(dart_4, 1.5, -0.4, 0.0);
		
		set_z_rotate(dart_5, 20, 1);
		set_x_rotate(dart_5, 9, 1);
		set_y_rotate(dart_5, -4, 1);
		set_translate(dart_5, -3.2, 5.5, 0.0);
		
		set_x_rotate(dart_1t, 3, 1);
		set_y_rotate(dart_1t, 45, 1);
		set_translate(dart_1t, -35.0, 39.8, 25.0);
		
		set_x_rotate(dart_2t, 3, 1);
		set_y_rotate(dart_2t, 20, 1);
		set_translate(dart_2t, -38.0, 39.8, 27.0);
		
	darts = create_list(dart_1, "darts_list");
		darts = insert_in_list(darts, dart_2);
		darts = insert_in_list(darts, dart_3);
		darts = insert_in_list(darts, dart_4);
		darts = insert_in_list(darts, dart_5); 
		darts = insert_in_list(darts, dart_1t);
		darts = insert_in_list(darts, dart_2t); 
	
	/*** OBJECT Tavolo ***/
	tavolo_base = read_nurbs("tavolo_sopraf_01.db");
		set_attribute(tavolo_base, glass_tavolo);
	tavolo_piedistallo = read_nurbs("tavolo_piedistallof_01.db");
		set_attribute(tavolo_piedistallo, metallo_piedistallo);
	tavolo_list = create_list(tavolo_base, "tavolo");
	tavolo_list = insert_in_list(tavolo_list, tavolo_piedistallo);
		set_scale(tavolo_list, 0.75, 0.75, 1.0);
		set_x_rotate(tavolo_list, 90, 1);
		set_translate(tavolo_list, -40.0, 40.0, 20.0); 	
	
	/*** OBJECT Muri, pavimento e soffitto ***/
	floor = read_nurbs("floor.db");
		set_scale(floor, 0.1, 0.1, 0.1);
		set_translate(floor,50,50,0);
		set_projection_texture(floor, colore_pavimento, "textures/cotto.hr", 1, TRUE, 0.6, 0.5);
		set_translate(floor,-50,-50,0);
		set_scale(floor, 10.0, 10.0, 10.0);

	muro_f = read_nurbs("muro_f.db");
		set_attribute(muro_f, muro);

	muro_b = create_copy(muro_f, "muro_b");
		set_translate(muro_f, 0.0, 0.0, 100.0);

	muro_l = read_nurbs("muro_l.db");
		set_attribute(muro_l, muro);

	muro_r = create_copy(muro_l, "muro_r");
		set_translate(muro_r, -120.0, 0.0, 0.0);
		
	soffitto = create_copy(floor, "soffitto");
		set_attribute(soffitto, muro);
		set_translate(soffitto, 0.0, -124.0, 0.0);
	
	muro_list = create_list(floor, "muri");
	muro_list = insert_in_list(muro_list, soffitto);
	muro_list = insert_in_list(muro_list, muro_b);
	muro_list = insert_in_list(muro_list, muro_f);
	muro_list = insert_in_list(muro_list, muro_r);
	muro_list = insert_in_list(muro_list, muro_l);
	
	/*** OBJECT Battiscopa ***/ 
	battiscopa_f = read_nurbs("battiscopa_02.db");
		set_attribute(battiscopa_f, colore_battiscopa);
		set_scale(battiscopa_f, 70, 5, 5);
		set_x_rotate(battiscopa_f, 90, 1);
		set_y_rotate(battiscopa_f, 180, 1);
		set_translate(battiscopa_f, 50.0, 64.0, -5.5);
		
	battiscopa_b = create_copy(battiscopa_f, "battiscopa_b");
		set_y_rotate(battiscopa_b, 180, 1);
		set_translate(battiscopa_b, -40.0, 0.0, 96.0);
	battiscopa_r = create_copy(battiscopa_f, "battiscopa_r");
		set_y_rotate(battiscopa_r, 90, 1);
		set_translate(battiscopa_r, -78.3, 0.0, 30.0);
	battiscopa_l = create_copy(battiscopa_f, "battiscopa_l");
		set_y_rotate(battiscopa_l, -90, 1);
		set_translate(battiscopa_l, 38.0, 0.0, 60.0);
	
	battiscopa_list = create_list(battiscopa_f, "battiscopa");
	battiscopa_list = insert_in_list(battiscopa_list, battiscopa_b);
	battiscopa_list = insert_in_list(battiscopa_list, battiscopa_r);
	battiscopa_list = insert_in_list(battiscopa_list, battiscopa_l);
	
	/*** OBJECT Bicchieri ***/ 
	bicchiere = read_nurbs("bicchiere_05f.db");
		set_domain_texture(bicchiere, glass_bicchiere, "textures/blu_gradient_07f.hr", 0, 1, 0, 1, FALSE, 0.8, 0.5);
	aperitivo = read_nurbs("acqua_02f.db");
		set_attribute(aperitivo, colore_aperitivo);
 
	ciliegia_corpo = read_nurbs("ciliegia_03f.db");
		set_attribute(ciliegia_corpo, colore_ciliegia);
	ciliegia_gambo = read_nurbs("ciliegia_gambo_03f.db");
		set_attribute(ciliegia_gambo, colore_gambo);
	ciliegia_finale = read_nurbs("ciliegia_finale_03f.db");
		set_attribute(ciliegia_finale, colore_finale);
	
	cherry_list = create_list(ciliegia_corpo, "cherry_1");
	cherry_list = insert_in_list(cherry_list, ciliegia_gambo);
	cherry_list = insert_in_list(cherry_list, ciliegia_finale);
		set_x_rotate(cherry_list, 49, 1);
		set_translate(cherry_list, 0, 3.7, 1.9);
	
	bicchiere_1 = create_list(bicchiere, "bicchiere_1");
	bicchiere_1 = insert_in_list(bicchiere_1, aperitivo);
	bicchiere_1 = insert_in_list(bicchiere_1, cherry_list);
		set_x_rotate(bicchiere_1, 90, 1);
		set_translate(bicchiere_1, -40.0, 39.3, 19.0);
	
	bicchiere_2 = create_copy(bicchiere_1, "bicchiere_2");
		set_translate(bicchiere_2, -6.0, 0.0, 5.0);
		
	bicchieri = create_list(bicchiere_1, "bicchieri_list");
	bicchieri = insert_in_list(bicchieri, bicchiere_2);

	/*** OBJECT Scena finale ***/
	scene = create_list(mobile, "scene");
	scene = insert_in_list(scene,darts);
	scene = insert_in_list(scene,griglia_list);
	scene = insert_in_list(scene,tavolo_list);
	scene = insert_in_list(scene, bicchieri);
	scene = insert_in_list(scene, muro_list);
	scene = insert_in_list(scene, battiscopa_list);
	scene = insert_in_list(scene, foglio);
	
	save_scene("darts.md","scene_draft",scene);
	return(0);
}
